/**************************************************************************/
/*                                                                        */
/*  The Why platform for program certification                            */
/*  Copyright (C) 2002-2008                                               */
/*    Romain BARDOU                                                       */
/*    Jean-Franois COUCHOT                                               */
/*    Mehdi DOGGUY                                                        */
/*    Jean-Christophe FILLITRE                                           */
/*    Thierry HUBERT                                                      */
/*    Claude MARCH                                                       */
/*    Yannick MOY                                                         */
/*    Christine PAULIN                                                    */
/*    Yann RGIS-GIANAS                                                   */
/*    Nicolas ROUSSET                                                     */
/*    Xavier URBAIN                                                       */
/*                                                                        */
/*  This software is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU Library General Public           */
/*  License version 2, with the special exception on linking              */
/*  described in file LICENSE.                                            */
/*                                                                        */
/*  This software is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  */
/*                                                                        */
/**************************************************************************/

//@ requires \valid_range(t, 0, n-1)
void f(int *t, int n) {
  int i;
  //@ invariant 0 <= i
  for (i = 0; i < n; i++)
    if (t[i] == 0) break;
  //@ assert i < n => t[i] == 0
}

/*@ requires 
  @   0 <= n && \valid_range(t, 0, n-1)
  @ assigns
  @   t[0..n-1]
  @ ensures 
  @   \forall int i, int j; 0 <= i <= j < n => t[i] <= t[j] */
void sort(int *t, int n);
